import { Score } from "../../server/db/interfaces";
import { GameState } from "./GameState";
import { GameSummary } from "./GameSummary";
import { MatchSessionOptions } from "./MatchSessionOptions";
import { PlayerDto } from "./PlayerDto";

export interface MatchSessionState {
  id: string;
  name: string;
  creator: string;
  players: PlayerDto[];
  seed: string;
  waitingForPlayers: boolean;
  mode: string;
  sessionInProgress: boolean;
  status: string;
  maxPlayers: number;
  numPlayers: number;
  waitingSeconds: number;
  scoreboard: Score[];
  matchWinner: PlayerDto | null;
  matchInProgress: boolean;
  playersReady: number,
  gameSummaries: GameSummary[];
  options: MatchSessionOptions
  currentGame?: GameState
  room: string
}