import { Response } from "express";
import { LoggingService } from "../../common/LoggingService";

export class BaseController {
  logger = new LoggingService().logger;

  handleError(res: Response, error: any, data = {}) {
    this.logger.error(error);
    res.status(500).json({ error: error.message, ...data }).end();
  }
}