import { Request, Response, Router } from 'express';
import { AuthController } from '../controllers/AuthController';
import { GameController } from '../controllers/GameController';



export default function(): Router {
  const router = Router();
  const gameController = new GameController();
  const { authenticate } = AuthController

  router.post('/match', authenticate({ roles: ['user']}), (req: Request, res: Response) => gameController.createMatch(req, res));
  router.get('/match', authenticate({ roles: ['user']}), (req: Request, res: Response) => gameController.listMatches(req, res)); 
  router.get('/match/:sessionId', authenticate({ roles: ['user']}), (req: Request, res: Response) => gameController.getMatch(req, res)); 
  router.put('/match/:sessionId', authenticate({ roles: ['user']}), (req: Request, res: Response) => gameController.joinMatch(req, res));
  router.delete('/match/:sessionId', authenticate({ roles: ['user']}), (req: Request, res: Response) => gameController.deleteMatch(req, res)); 

  return router;
}
